# TODO 
#  initscript nuauth to revise ??

%define name	nufw
%define version 1.0.16
%define release %mkrel 1

%define libname %mklibname nuclient 0

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	Authentication Firewall Suite for Linux
License:	GPL
Group:		Networking/Other
Source:		http://www.nufw.org/download/nufw/%{name}-%{version}.tar.bz2
Source1:    nufw.init.bz2
Source2:    nuauth.init.bz2
URL:		http://www.nufw.org/
Requires(post): rpm-helper
Requires(postun): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
BuildRequires: postgresql-devel mysql-devel	gdbm-devel 
BuildRequires: gnutls-devel glib2-devel pam-devel libsasl2-devel 
BuildRequires: openldap-devel iptables-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}/buildroot

%description
NuFW is a firewall able to filter connection according to user uid or user 
software, meaning you can allows port 80 for only one user, whatever ip he 
uses, or only for konqueror.

NuFW performs an authentication of every single connection passing through the 
IP filter, by transparently requesting user's credentials before any filtering 
decision is taken. Practically, this means security policies can integrate with
the users directory, and bring the notion of user ID down to the IP layers.

%package utils
Summary:   Various utilities for Nufw administrators
Group:     Networking/Other
%description utils
This package contains various utilities :

  * nutop : a top-like utility to watch connection 

  * nutcpc : a console client to authenticate on nuauth gateway

  * nufw_dbm : a utility to mange list of user in a dbm file

  * nuaclgen : a perl script to add users to ldap

%package -n %libname
Summary:   Nuclient library
Group:     System/Libraries
%description -n %libname
Library needed by nufw for nuclient.

%package -n %libname-devel
Summary:   Nuclient development library
Group:     System/Libraries
Provides:  libnuclient-devel
Requires:  %libname = %version
%description -n %libname-devel
Development file of the nuclient library, used to compile
client accessing to nufw.

%package nutcpc
Summary: Nufw client
Group:   Networking/Other
%description nutcpc
Nutcpc is the command line client used to authenticate on a firewall using 
nufw.

%package  nuauth
Summary:   Nufw user database daemon
Group:     Networking/Other
Requires:  nufw-nuauth-auth nufw-nuauth-log
Requires(post): rpm-helper
Requires(postun): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper

%description   nuauth
NuFW is an authenticating gateway, which means that connections are 
authenticated before being forwarded through the gateway. Classical packet 
filtering systems disregard the identity of the user who may be attempting 
to access the network, instead caring only about the originating IP addresses. 

Nuauth lays on a user database, and an ACL system (which can reside in an LDAP 
directory, or XML/DBM solutions, etc. Nuauth receives requests from nufw, and 
auth packets from users' clients, and sends decision to the nufw daemon.

This package contains the main daemon.

%package nuauth-auth-dbm
Provides:  nufw-nuauth-auth
Summary:   Module for nuauth providing dbm file user database
Group:     Networking/Other
%description  nuauth-auth-dbm
This package provides a module to use a dbm file as user database for nuauth.

%package nuauth-auth-system
Provides:  nufw-nuauth-auth
Summary:   Module for nuauth providing system file user database
Group:     Networking/Other
%description nuauth-auth-system
This package provides a module to use system files as user database for nuauth.


%package nuauth-auth-ldap
Provides:  nufw-nuauth-auth
Summary:   Module for nuauth providing ldap user database
Group:     Networking/Other
%description nuauth-auth-ldap
This package provides a module to use ldap as user database for nuauth.

%package nuauth-auth-plaintext
Provides:  nufw-nuauth-auth
Summary:   Module for nuauth providing plaintext user database
Group:     Networking/Other
%description nuauth-auth-plaintext
This package provides a module to use plaintext file as user database for 
nuauth.

%package nuauth-log-syslog
Provides:  nufw-nuauth-log
Summary:   Module for nuauth to log using syslog
Group:     Networking/Other
%description nuauth-log-syslog
This module allows you to log user activity using syslog.

%package nuauth-log-mysql
Provides:  nufw-nuauth-log
Summary:   Module for nuauth to log in Mysql database
Group:     Networking/Other
%description nuauth-log-mysql
This module allows you to log user activity in a mysql database.

%package nuauth-log-pgsql
Provides:  nufw-nuauth-log
Summary:   Module for nuauth to log in Postgresql database
Group:     Networking/Other
%description nuauth-log-pgsql
This module allows you to log user activity in a postgresql database.


%prep
%setup -q
#%patch -p0
perl -pi -e "s|postgresql|pgsql|" ./src/nuauth/modules/log_pgsql/Makefile*

%build
# there is no ident library
%configure --with-mysql-log --with-pgsql-log --with-ldap --with-system-auth --with-gdbm --with-user-mark --localstatedir=%_var  
%make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

cp scripts/nuaclgen $RPM_BUILD_ROOT/%{_bindir}
cp scripts/nutop    $RPM_BUILD_ROOT/%{_bindir}

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/nufw
cp conf/{nutop,nuaclgen}.conf  $RPM_BUILD_ROOT/%{_sysconfdir}/nufw

mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/nuauth

# clean useless files
rm -f $RPM_BUILD_ROOT/%{_libdir}/nuauth/modules/*.{a,la,so}

mkdir -p $RPM_BUILD_ROOT/%_initrddir/
bzcat %SOURCE1 > $RPM_BUILD_ROOT/%_initrddir/nufw
bzcat %SOURCE2 > $RPM_BUILD_ROOT/%_initrddir/nuauth
chmod 755 $RPM_BUILD_ROOT/%_initrddir/*
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/
cat > $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/nufw << EOF
# daemon verbosity
#VERBOSITY="vv"

# address where nufw listen ( -L )
#LISTEN_ADDRESS="127.0.0.1"

# default port -l
#LISTEN_UDP_PORT="4129"

# nuauth address ( -d )
#NUAUTH_ADDRESS="127.0.0.1"

# nuauth port ( -p )
#NUAUTH_UDP_PORT=4128

# Firewall timeout ( -t )
#FW_TIMEOUT=15

# Track size ( -T )
#TRACK_SIZE=1000


EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%post 
%_post_service nufw

%preun 
%_preun_service nufw

# nuauth
%pre nuauth
%_pre_useradd nuauth %{_localstatedir}/nuauth /bin/false

%post nuauth
%_post_service nuauth

%postun nuauth
%_postun_userdel nuauth

%preun nuauth
%_preun_service nuauth



%files
%defattr(-, root, root)
%doc AUTHORS ChangeLog NEWS README TODO
%doc doc
%{_sbindir}/nufw
%{_mandir}/man1/nufw.1*
%config(noreplace) %{_initrddir}/nufw
%config(noreplace) %{_sysconfdir}/sysconfig/nufw

%files utils
%defattr(-, root, root)
%{_bindir}/nuaclgen
%{_bindir}/nutop
%{_bindir}/nufw_dbm
%{_mandir}/man1/nuaclgen.1*
%{_mandir}/man1/nutop.1*
%{_mandir}/man1/nufw_dbm.1*
%config(noreplace) %{_sysconfdir}/nufw/nutop.conf
%config(noreplace) %{_sysconfdir}/nufw/nuaclgen.conf
%dir %{_sysconfdir}/nufw/

%files -n %libname
%defattr(-, root, root)
%{_libdir}/libnuclient.so.*

%files -n %libname-devel
%defattr(-, root, root)
%{_libdir}/libnuclient.a
%{_libdir}/libnuclient.la
%{_libdir}/libnuclient.so
%{_includedir}/*
%{_mandir}/man3/libnuclient.3*

%files nuauth-auth-dbm
%defattr(-, root, root)
%{_libdir}/nuauth/modules/libdbm.so.*

%files nuauth-auth-ldap
%defattr(-, root, root)
%doc conf/acls.schema
%{_libdir}/nuauth/modules/libldap.so.*

%files nuauth-auth-plaintext
%defattr(-, root, root)
%{_libdir}/nuauth/modules/libplaintext.so.*

%files nuauth-auth-system
%defattr(-, root, root)
%{_libdir}/nuauth/modules/libsystem.so.*

%files nuauth-log-syslog
%defattr(-, root, root)
%{_libdir}/nuauth/modules/libsyslog.so.*

%files nuauth-log-mysql
%defattr(-, root, root)
%doc conf/nulog*mysql.dump
%{_libdir}/nuauth/modules/libmysql.so.*

%files nuauth-log-pgsql
%defattr(-, root, root)
%doc conf/nulog*pgsql.dump
%{_libdir}/nuauth/modules/libpgsql.so.*

%files nuauth
%defattr(-, root, root)
%{_sbindir}/nuauth
%{_mandir}/man1/nuauth.1*
%{_localstatedir}/nuauth
%config(noreplace) %{_initrddir}/nuauth

%files nutcpc
%defattr(-, root, root)
%{_bindir}/nutcpc
%{_mandir}/man1/nutcpc.1*

%changelog
* Fri Dec 09 2005 Michael Scherer <misc@mandriva.org> 1.0.16-0.1.20060mdk
- rebuild from cooker, security update 

* Wed Dec 07 2005 Michael Scherer <misc@mandriva.org> 1.0.16-1mdk
- New release 1.0.16

* Fri Nov 18 2005 Michael Scherer <misc@mandriva.org> 1.0.15-1mdk
- New release 1.0.15

* Fri Sep 30 2005 Michael Scherer <misc@mandriva.org> 1.0.13-1mdk
- New release 1.0.13
- patch 1 removed, applied upstream

* Tue Sep 06 2005 Michael Scherer <misc@mandriva.org> 1.0.12-1mdk
- New release 1.0.12
- patch to compile with new ldap

* Sun Aug 28 2005 Michael Scherer <misc@mandriva.org> 1.0.11-2mdk
- missing buildrequires

* Sun Aug 28 2005 Michael Scherer <misc@mandriva.org> 1.0.11-1mdk
- First version ( at last )
